SystemOrganization addCategory: #'SleepyCoders-WalkieTalkie'!
SystemOrganization addCategory: #'SleepyCoders-WalkieTalkie-Tests'!

TestCase subclass: #WalkieTalkieTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SleepyCoders-WalkieTalkie-Tests'!

!WalkieTalkieTests methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 06:06'!
testWalkieToTolkieConnection
	"comment stating purpose of message"

	| listener talker |
	listener := WalkieTalkie new initializeAsListenerOnIP: #[127 0 0 1] port: 12345.
	talker := WalkieTalkie new initializeAsTalkerToHost: '127.0.0.1' port: 12345.
	self assert: listener paired.
	self assert: talker paired.! !

Object subclass: #WalkieTalkie
	instanceVariableNames: 'session process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SleepyCoders-WalkieTalkie'!

!WalkieTalkie methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 06:21'!
disconnect
	"If I'm paired disconnect me from my partner."

	"Terminate listener fork if it in wome way still is running."
	process terminate.

	"Disconnect from pairde socket."
	(self paired) ifTrue: [
		session closeAndDestroy].! !

!WalkieTalkie methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/16/2012 07:02'!
initializeAsListenerOnIP: ip port: port

	process := [
		|socket|
		socket := Socket newTCP.
		[session isNil] whileTrue:
		[
			socket listenOn: port backlogSize: 50 interface: ip.
			session := socket waitForAcceptFor: 60.
			Processor yield.
		]
		socket closeAndDestroy.
	] fork.! !

!WalkieTalkie methodsFor: 'initialization' stamp: 'imy 4/16/2012 06:42'!
initializeAsTalkerToHost:host port: port
	session := Socket newTCP.
  	[session connectToHostNamed: host port: port] 
		on: ConnectionTimedOut 
		do: [ :sig | sig return: nil].! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 03:42'!
paired
"returns true if walkie is paird with another one. ei session ivar is set up"

	^(session isNil not) and: (session isConnected).! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'YuriyTymchuk 4/16/2012 03:51'!
read
"reads data available on the walkie"
	
	(self unread) ifTrue:
	[
		^ReferenceStream unStream: session receiveData.
	].
	^nil.! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'imy 4/16/2012 05:52'!
send: data
	"Send data to the other walkie"

	(self paired) ifTrue: [
		session sendSomeData: (ReferenceStream streamedRepresentationOf:  data)]! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 02:26'!
unread
"Returns true if walkie has unread data"

	^session dataAvailable.! !
